
#include <global.h>
#include <random_map.h>
#include <style.h>


/* orientation:  0 means random,
  1 means descending dungeon
  2 means ascending dungeon
  3 means rightward
  4 means leftward
  5 means northward
  6 means southward
*/

void place_exits(mapstruct *map, char **maze,char *exitstyle,int orientation) {
  char styledirname[256];
  mapstruct *style_map_down=0;  /* harder maze */
  mapstruct *style_map_up=0;    /* easier maze */
  object *the_exit_down;        /* harder maze */
  object *the_exit_up;          /* easier maze */
  object *random_sign;          /* magic mouth saying this is a random map. */
  int cx=-1,cy=-1;  /* location of a map center */

  if(orientation == 0) orientation = RANDOM() % 6 + 1;

  switch(orientation) {
  case 1:
    {
      sprintf(styledirname,"/styles/exitstyles/up");
      style_map_up = find_style(styledirname,exitstyle,-1);
      sprintf(styledirname,"/styles/exitstyles/down");
      style_map_down = find_style(styledirname,exitstyle,-1);
      break;
    }
  case 2:
    {
      sprintf(styledirname,"/styles/exitstyles/down");
      style_map_up = find_style(styledirname,exitstyle,-1);
      sprintf(styledirname,"/styles/exitstyles/up");
      style_map_down = find_style(styledirname,exitstyle,-1);
      break;
    }
  default:
    {
      sprintf(styledirname,"/styles/exitstyles/generic");
      style_map_up = find_style(styledirname,exitstyle,-1);
      style_map_down = style_map_up;
      break;
    }
  }
  if(style_map_up == 0) the_exit_up =arch_to_object(find_archetype("exit"));
  else {
    object *tmp;
    tmp = pick_random_object(style_map_up);
    the_exit_up = arch_to_object(tmp->arch);
  }

  /* we need a down exit only if we're recursing. */
  if(dungeon_level < dungeon_depth)
    if(style_map_down == 0) the_exit_down = arch_to_object(find_archetype("exit"));
    else {
      object *tmp;
      tmp = pick_random_object(style_map_down);
      the_exit_down = arch_to_object(tmp->arch);
    }
  else the_exit_down = 0;

  /* set up the down exit */
  the_exit_up->stats.hp = origin_x;
  the_exit_up->stats.sp = origin_y;
  the_exit_up->slaying = add_string(origin_map);

  /* figure out where to put the entrance */
  /* begin a logical block */
  {
    int ex=-1,ey=-1;
    int i,j;
    /* first, look for a C, the map center.  */
    for(i=0;i<Xsize&&cx==-1;i++)
      for(j=0;j<Ysize;j++) {
		  if(maze[i][j]=='C') {
			 cx = i; cy=j; break;
		  }
      }
    if(cx!=-1) {
      if(cx > Xsize/2) ex = 1;
      else ex = Xsize -2;
      if(cy > Ysize/2) ey = 1;
      else ey = Ysize -2;
    }
    else {
		ex = RANDOM() % (Xsize-2) +1;
		ey = RANDOM() % (Ysize-2) +1;
    }
	 i = find_first_free_spot(the_exit_up->arch,map,ex,ey);
	 the_exit_up->x = ex + freearr_x[i];
	 the_exit_up->y = ey + freearr_y[i];
	 random_sign = get_archetype("magic_mouth");
	 random_sign->x = the_exit_up->x;
	 random_sign->y = the_exit_up->y;
	 random_sign->msg = add_string("You have just entered a random map.\n");
	 insert_ob_in_map(random_sign,map);
	 insert_ob_in_map(the_exit_up,map);
	 /* set the starting x,y for this map */
	 map->map_object->stats.hp=the_exit_up->x;
	 map->map_object->stats.sp=the_exit_up->y;
   
	 /* make the other exit far away from this one if
		 there's no center. */
	 if(cx==-1) {
		if(ex > Xsize/2) cx = 1;
		else cx = Xsize -2;
		if(ey > Ysize/2) cy = 1;
		else cy = Ysize -2;
	 };

	 if(the_exit_down) {
		char buf[2048];
		i = find_first_free_spot(the_exit_down->arch,map,cx,cy);
		the_exit_down->x = cx + freearr_x[i];
		the_exit_down->y = cy + freearr_y[i];
		origin_x = the_exit_down->x;
		origin_y = the_exit_down->y;
		write_map_parameters_to_string(buf);
		the_exit_down->msg = add_string(buf);
		/* the identifier for making a random map. */
		the_exit_down->slaying = add_string("/!");
		insert_ob_in_map(the_exit_down,map);
	 }
  }     
    
}
